//---------------------------------------------------------------------------
// Copyright (C) 2001 by Dmitriy Vassiliev
// slydiman@mailru.com
// http://slydiman.narod.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DevCmbDC.h"

#pragma package(smart_init)
#pragma resource "*.res"

//---------------------------------------------------------------------------
namespace Devcmbdc
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TDCaptureDevCombo)};
        RegisterComponents("SlyDiman", classes, 0);
    }                         
}

//---------------------------------------------------------------------------
__fastcall TDCaptureDevCombo::TDCaptureDevCombo(TComponent* Owner) : TCustomComboBox(Owner)
{
  Sorted = false;
  FDefDriver = 0;
  Style = csDropDownList;
}

//----------------------------------------------------------------------------
BOOL CALLBACK DCEnumProc( LPGUID lpGUID, LPSTR lpszDesc, LPSTR lpszDrvName, LPVOID lpContext )
{
  LPGUID lpTemp = NULL;

  if( lpGUID != NULL ){
    lpTemp = (LPGUID)LocalAlloc( LPTR, sizeof(GUID) );
	if( lpTemp == NULL )  return( TRUE );
	memcpy( lpTemp, lpGUID, sizeof(GUID) );
  }

//  lpTemp = lpGUID;

  TDCaptureDevCombo *DCaptureDevCombo = (TDCaptureDevCombo *)lpContext;
  DCaptureDevCombo->Items->AddObject( AnsiString(lpszDesc), (TObject *)lpTemp );

  return( TRUE );
}

//---------------------------------------------------------------------------
void __fastcall TDCaptureDevCombo::DestroyWnd(void)
{
  for( int i=0; i < Items->Count; i++ )
    if( Items->Objects[i] )  LocalFree( Items->Objects[i] );

  TCustomComboBox::DestroyWnd();
}

//---------------------------------------------------------------------------
void __fastcall TDCaptureDevCombo::CreateWnd(void)
{
  TCustomComboBox::CreateWnd();

  Init();
}

//---------------------------------------------------------------------------
void __fastcall TDCaptureDevCombo::Init(void)
{
  DirectSoundCaptureEnumerate( (LPDSENUMCALLBACK)DCEnumProc, this );
  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
void __fastcall TDCaptureDevCombo::SetDefDriver( LPGUID Device )
{
  FDefDriver = 0;

  for( int i=Items->Count-1; i>=0; i-- ){
    if( (LPGUID)Items->Objects[i] == Device ){
      FDefDriver = i;
      break;
    }
  }

  ItemIndex = FDefDriver;
}

//---------------------------------------------------------------------------
LPGUID __fastcall TDCaptureDevCombo::GetDefDriver( void )
{
  return( (LPGUID)Items->Objects[ItemIndex] );
}

//---------------------------------------------------------------------------
